--Port of R Skin v2.1 (4k)
-- 24/07/2020

local Noteskin = ... or {};
local button = Var "Button"

--Column redirs. Controls colour sets for each column. This is not configurable per keymode at the moment
--However, you can have different sets per gamemode
--This means that 4k and 7k can have separate column layouts
--At the same time, 4k and 6k can't because they are in the same gamemode
--In Etterna .69 solo has been made its own gamemode so maybe that last point is not true anymore,
--but it's not something I've tested yet
Noteskin.ButtonRedirs = {
	--Dance(4k/6k/8k)
	Left		= "White";
	Down		= "Blue";
	UpLeft		= "Blue";
	Up			= "Blue";
	UpRight		= "Blue";
	Right		= "White";
	
	--kb7(7k)
	Key1		= "White";
	Key2		= "Blue";
	Key3		= "White";
	Key4		= "Yellow";
	Key5		= "White";
	Key6		= "Blue";
	Key7		= "White";
};

--Element redirects
Noteskin.ElementRedirs = {

	--Make dim and bright explosion the same
	["Tap Explosion Dim"] = "Tap Explosion Bright";

	--Blank out hold heads and tails
	["Hold Head Active"] 	= "Zblank";
	["Hold Head Inactive"] 	= "Zblank";
	["Roll Head Active"] 	= "Zblank";
	["Roll Head Inactive"] 	= "Zblank";
	["Hold TopCap Active"]		= "Zblank";
	["Hold TopCap Inactive"]	= "Zblank";
	["Roll TopCap Active"]		= "Zblank";
	["Roll TopCap Inactive"]	= "Zblank";
	["Hold Tail Active"] 	= "Zblank";
	["Hold Tail Inactive"] 	= "Zblank";
	["Roll Tail Active"] 	= "Zblank";
	["Roll Tail Inactive"] 	= "Zblank";

	--Redirect hold bodies
	["Hold Body Active"]		= "Hold Body";
	["Hold Body Inactive"]		= "Hold Body";
	["Roll Body Active"]		= "Roll Body";
	["Roll Body Inactive"]		= "Roll Body";

	--Make rolls and holds share explosions
	["Roll Explosion"]			= "Hold Explosion";

	--Redirect mines
	["Tap Mine"]				= "Mine Dot";
};

--Invisible elements
Noteskin.Hide = {
	["Tap Fake"] 				= true;
	["Tap Lift"] 				= true;
};

--Rotations
Noteskin.BaseRotX = {
	Left	= 0;
	UpLeft	= 0;
	Up		= 0;
	Down	= 0;
	UpRight	= 0;
	Right	= 0;
};
Noteskin.BaseRotY = {
	Left	= 0;
	UpLeft	= 0;
	Up		= 0;
	Down	= 0;
	UpRight	= 0;
	Right	= 0;
};

--This part loads elements but I honestly have no clue how it works
local function NoteskinLoader()
	local Button = Var "Button"
	local Element = Var "Element"

	if Noteskin.Hide[Element] then
		--Return a blank element. If SpriteOnly is set, we need to return a
		--sprite; otherwise just return a dummy actor.
		local t;
		if Var "SpriteOnly" then
			t = LoadActor( "_blank" );
		else
			t = Def.Actor {};
		end
		return t .. {
			InitCommand = function(self)
    			self:visible(false)
  			end
		};
	end;


	--Load element and button, using redirs
	local LoadElement = Noteskin.ElementRedirs[Element]
	if not LoadElement then
		LoadElement = Element;
	end;

	local LoadButton = Noteskin.ButtonRedirs[Button]
	if not LoadButton then
		LoadButton = Button;
	end;

	--Get path to thing
	local sPath = NOTESKIN:GetPath( LoadButton, LoadElement );

	--Make actor
	local t = LoadActor( sPath );

	--Apply rotation
	t.BaseRotationX=Noteskin.BaseRotX[sButton]
	t.BaseRotationY=Noteskin.BaseRotY[sButton]
	
	return t;
end

Noteskin.Load = NoteskinLoader;
Noteskin.CommonLoad = NoteskinLoader;
return Noteskin;