local button = Var "Button"

--Define buttons as column numbers(left to right)
local mapping_four = {
	Left = 0,
	Down = 1,
	Up = 2,
	Right = 3
}
local mapping_six = {
	Left = 0,
	UpLeft = 1,
	Down = 2,
	Up = 3,
	UpRight = 4,
	Right = 5
}

--Count columns(used below to isolate JudgmentMessageCommand to specific columns)
local function shouldBomb(column, count)
	if count == 6 then
		return mapping_six[button] == column
	elseif count == 4 then
		return mapping_four[button] == column
	else
		return false
	end
end


local t = Def.ActorFrame{
	--This chaotic line makes sure the original aspect ratio for explosions are kept even when you scale the notefield with customize gameplay
	--Without this, the explosions would get squished or stretched when scaling the notefield
	--It scales the entire actorframe instead of the explosions themselves to make sure it doesn't interfere with the explosion tweens
	InitCommand=function(self)
		local keymode = getCurrentKeyMode()
			self:zoomx(1/playerConfig:get_data(pn_to_profile_slot(PLAYER_1)).GameplaySizes[keymode].NotefieldWidth)
			self:zoomy(1/playerConfig:get_data(pn_to_profile_slot(PLAYER_1)).GameplaySizes[keymode].NotefieldHeight)
	end,

--The following mess is supposed to hide hold explosions when the holds are 16ths or shorter,
--but it ends up hiding the effect on longer holds sometimes as well
	Def.Sprite {
		--Choose texture based on preferences in metrics.ini
		Texture="bomb hold off";
		Frames=Sprite.LinearFrames(2,0.128);
		InitCommand=function(self)
			self:blend("BlendMode_Add"):diffusealpha(1):zoom(2.5)
		end,
		JudgmentMessageCommand=function(self, params)
			if params.Type ~= "Hold" then return end
			if params.Judgment ~= "HoldNoteScore_Held" then return end
			if shouldBomb(params.FirstTrack, params.NumTracks) then
				local tn = params.TapNote
				local length = tn:GetHoldDuration()
				if length >= 0.26 then
					self:diffusealpha(1):blend("BlendMode_Add"):zoom(2.5)
				elseif length < 0.25 then
					self:diffusealpha(0):blend("BlendMode_Add"):zoom(2.5)
				end
			end
		end,
	};


};

return t;